grk::PrecinctImpl Struct Reference

`#include <Precinct.h>`

## Public Member Functions

| PrecinctImpl (bool isCompressor, grk_rect32 *bounds, grk_pt32 cblk_expn)
| ~PrecinctImpl (void)
grk_rect32 | getCodeBlockBounds (uint64_t cblkno)
bool | initCodeBlocks (uint16_t numLayers, grk_rect32 *bounds)
template<typename T >
bool | initCodeBlock (T *block, uint64_t cblkno)
void | deleteTagTrees ()
TagTreeU16 * | getIncludeTagTree (void)
TagTreeU8 * | getIMsbTagTree (void)

## Public Attributes

BlockCache< CompressCodeblock, PrecinctImpl > * | enc
BlockCache< DecompressCodeblock, PrecinctImpl > * | dec
grk_rect32 | cblk_grid_
grk_rect32 | bounds_
grk_pt32 | cblk_expn_
bool | isCompressor_

## Private Attributes

TagTreeU16 * | incltree
TagTreeU8 * | imsbtree

## Constructor & Destructor Documentation

## PrecinctImpl()

grk::PrecinctImpl::PrecinctImpl | ( | bool | isCompressor,
|  | grk_rect32 * | bounds,
|  | grk_pt32 | cblk_expn
| ) |  |

References cblk_grid_, grk::floordivpow2(), grk::GRK_ERROR(), grk::grk_read(), grk::grk_rect< T >::valid(), grk::grk_rect< T >::x0, grk::grk_rect< T >::x1, grk::grk_rect< T >::y0, and grk::grk_rect< T >::y1.

## ~PrecinctImpl()

grk::PrecinctImpl::~PrecinctImpl | ( | void |  | ) |

References dec, deleteTagTrees(), and enc.

## Member Function Documentation

## deleteTagTrees()

void grk::PrecinctImpl::deleteTagTrees | ( |  | ) |

References imsbtree, and incltree.

Referenced by grk::Precinct::deleteTagTrees(), and ~PrecinctImpl().

## getCodeBlockBounds()

grk_rect32 grk::PrecinctImpl::getCodeBlockBounds | ( | uint64_t | cblkno | ) |

References bounds_, cblk_expn_, cblk_grid_, grk::grk_read(), grk::grk_rect< T >::width(), grk::grk_pt< T >::x, grk::grk_rect< T >::x0, grk::grk_pt< T >::y, and grk::grk_rect< T >::y0.

Referenced by grk::Precinct::getCodeBlockBounds(), and initCodeBlock().

## getIMsbTagTree()

TagTreeU8 * grk::PrecinctImpl::getIMsbTagTree | ( | void |  | ) |

References cblk_grid_, grk::grk_read(), grk::GRK_WARN(), grk::grk_rect< T >::height(), imsbtree, and grk::grk_rect< T >::width().

Referenced by grk::Precinct::getImsbTree().

## getIncludeTagTree()

TagTreeU16 * grk::PrecinctImpl::getIncludeTagTree | ( | void |  | ) |

References cblk_grid_, grk::grk_read(), grk::GRK_WARN(), grk::grk_rect< T >::height(), incltree, and grk::grk_rect< T >::width().

Referenced by grk::Precinct::getInclTree().

## initCodeBlock()

template<typename T >

bool grk::PrecinctImpl::initCodeBlock | ( | T * | block,
|  | uint64_t | cblkno
| ) |  |

References getCodeBlockBounds(), and grk::grk_read().

## initCodeBlocks()

bool grk::PrecinctImpl::initCodeBlocks | ( | uint16_t | numLayers,
|  | grk_rect32 * | bounds
| ) |  |

References grk::grk_rect< T >::area(), bounds_, cblk_grid_, dec, enc, grk::grk_read(), and isCompressor_.

Referenced by grk::Precinct::getImpl().

## Member Data Documentation

## bounds_

grk_rect32 grk::PrecinctImpl::bounds_

Referenced by getCodeBlockBounds(), and initCodeBlocks().

## cblk_expn_

grk_pt32 grk::PrecinctImpl::cblk_expn_

Referenced by getCodeBlockBounds(), and grk::Precinct::getNominalBlockSize().

## cblk_grid_

grk_rect32 grk::PrecinctImpl::cblk_grid_

Referenced by grk::Precinct::getCblkGrid(), grk::Precinct::getCblkGridHeight(), grk::Precinct::getCblkGridwidth(), getCodeBlockBounds(), getIMsbTagTree(), getIncludeTagTree(), grk::Precinct::getNumCblks(), initCodeBlocks(), and PrecinctImpl().

## dec

BlockCache<DecompressCodeblock, PrecinctImpl>* grk::PrecinctImpl::dec

Referenced by grk::Precinct::getDecompressedBlockPtr(), initCodeBlocks(), grk::Precinct::tryGetDecompressedBlockPtr(), and ~PrecinctImpl().

## enc

BlockCache<CompressCodeblock, PrecinctImpl>* grk::PrecinctImpl::enc

Referenced by grk::Precinct::getCompressedBlockPtr(), initCodeBlocks(), and ~PrecinctImpl().

## imsbtree

TagTreeU8* grk::PrecinctImpl::imsbtree

private

Referenced by deleteTagTrees(), and getIMsbTagTree().

## incltree

TagTreeU16* grk::PrecinctImpl::incltree

private

Referenced by deleteTagTrees(), and getIncludeTagTree().

## isCompressor_

bool grk::PrecinctImpl::isCompressor_

Referenced by initCodeBlocks().

The documentation for this struct was generated from the following files:

- Precinct.h
- Precinct.cpp